diff -ruN qmail-1.03-orig/qmail-smtpd.c qmail-1.03-ldap-20060201-orig/qmail-smtpd.c
--- qmail-1.03-orig/qmail-smtpd.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-smtpd.c	2006-02-25 11:00:55.000000000 +0100
@@ -197,78 +537,761 @@
   return 1;
 }
 
-int bmfcheck()
+stralloc checkhost = {0};
+ipalloc checkip = {0};
+
+int badmxcheck(char *dom)
+{
+  int ret = 0;
+  unsigned long r;
+
+  if (!*dom) return (DNS_HARD);
+  if (!stralloc_copys(&checkhost,dom)) return (DNS_SOFT);
+
+  r = now() + (getpid() << 16);
+  switch (dns_mxip(&checkip,&checkhost,r))
+  {
+    case DNS_MEM:
+    case DNS_SOFT:
+         ret = DNS_SOFT;
+         break;
+    case DNS_HARD:
+         ret = DNS_HARD;
+         break;
+    case 1:
+         if (checkip.len <= 0) ret = DNS_SOFT;
+         break;
+    default:
+         if (checkip.len <= 0) ret = DNS_HARD;
+         break;
+  }
+  return (ret);
+}
+
+stralloc parameter = {0};
+
+char *getparameter(char *arg, const char *name)
+{
+  unsigned int i;
+  char ch;
+  char terminator;
+  int flagesc;
+  int flagquoted;
+
+  terminator = '>';
+  i = str_chr(arg,'<');
+  if (arg[i])
+    arg += i + 1;
+  else { /* partner should go read rfc 821 */
+    terminator = ' ';
+    arg += str_chr(arg,':');
+    if (*arg == ':') ++arg;
+    while (*arg == ' ') ++arg;
+  }
+
+  flagesc = 0;
+  flagquoted = 0;
+  for (i = 0;(ch = arg[i]);++i) { /* skipping addr, respecting quotes */
+    if (flagesc) {
+      flagesc = 0;
+    } else {
+      if (!flagquoted && (ch == terminator)) break;
+      switch(ch) {
+        case '\\': flagesc = 1; break;
+        case '"': flagquoted = !flagquoted; break;
+        default: break;
+      }
+    }
+  }
+  if (!arg[i++]) return (char *)0; /* no parameters */
+  arg += i;
+  do {
+    while (*arg == ' ') if (!*arg++) return (char *)0;
+    if (case_diffb(arg, str_len(name), name) == 0) {
+      arg += str_len(name);
+      if (*arg++ == '=') {
+	i = str_chr(arg, ' ');
+	if (!stralloc_copyb(&parameter, arg, i)) die_nomem();
+	if (!stralloc_0(&parameter)) die_nomem();
+	return parameter.s;
+      }
+    }
+    while (*arg != ' ') if (!*arg++) return (char *)0;
+  } while (1);
+}
+
+int sizelimit(char *arg)
 {
-  int j;
+  char *size;
+  unsigned long sizebytes = 0;
+
+  size = getparameter(arg, "SIZE");
+  if (!size) return 1;
+
+  scan_ulong(size, &sizebytes);
+  return databytes >= sizebytes;
+}
+
+
+int bmfcheck(void)
+{
+  unsigned int j;
+
   if (!bmfok) return 0;
   if (constmap(&mapbmf,addr.s,addr.len - 1)) return 1;
   j = byte_rchr(addr.s,addr.len,'@');
   if (j < addr.len)
+  {
     if (constmap(&mapbmf,addr.s + j,addr.len - j - 1)) return 1;
+    if (constmap(&mapbmf,addr.s, j + 1)) return 1;
+  }
+  return 0;
+}
+
+int bmfunknowncheck(void)
+{
+  unsigned int j;
+
+  if (!bmfunknownok) return 0;
+  if (case_diffs(remotehost,"unknown")) return 0;
+  if (constmap(&mapbmfunknown,addr.s,addr.len - 1)) return 1;
+  j = byte_rchr(addr.s,addr.len,'@');
+  if (j < addr.len)
+    if (constmap(&mapbmfunknown,addr.s + j,addr.len - j - 1)) return 1;
   return 0;
 }
 
-int addrallowed()
+int seenmail = 0;
+stralloc mailfrom = {0};
+stralloc rcptto = {0};
+unsigned int rcptcount;
+
+int rmfcheck(void)
+{
+  unsigned int j;
+
+  if (!rmfok) return 0;
+  if (constmap(&maprmf,addr.s,addr.len - 1)) return 1;
+  j = byte_rchr(addr.s,addr.len,'@');
+  if (j < addr.len)
+    if (constmap(&maprmf,addr.s + j,addr.len - j - 1)) return 1;
+  return 0;
+}
+
+int addrallowed(void)
 {
   int r;
-  r = rcpthosts(addr.s,str_len(addr.s));
+
+  r = rcpthosts(addr.s,addr.len - 1);
   if (r == -1) die_control();
   return r;
 }
 
+int addrlocals(void)
+{
+  int r;
 
-int seenmail = 0;
-int flagbarf; /* defined if seenmail */
-stralloc mailfrom = {0};
-stralloc rcptto = {0};
+  r = localhosts(addr.s, addr.len - 1);
+  if (r == -1) die_control();
+  return r;
+}
+
+int rcptdenied(void)
+{
+  unsigned int j;
+
+  if (!brtok) return 0;
+  if (constmap(&mapbadrcptto, addr.s, addr.len - 1)) return 1;
+  j = byte_rchr(addr.s,addr.len,'@');
+  if (j < addr.len)
+    if (constmap(&mapbadrcptto, addr.s + j, addr.len - j - 1))
+      return 1;
+  return 0;
+}
+
+stralloc gmaddr;
+
+int goodmailaddr(void)
+{
+  unsigned int at;
+#ifdef DASH_EXT
+  unsigned int ext;
+  int extcnt;
+#endif
+
+  if (!gmaok) return 0;
+  if (constmap(&mapgma, addr.s, addr.len - 1)) return 1;
+  at = byte_rchr(addr.s,addr.len,'@');
+  if (at < addr.len) {
+    if (constmap(&mapgma, addr.s + at, addr.len - at - 1))
+      return 1;
+    if (constmap(&mapgma, addr.s, at + 1))
+      return 1;
+#ifdef DASH_EXT
+    /* foo-catchall@domain.org */
+    for (ext = 0, extcnt = 1; ext < at && extcnt <= DASH_EXT_LEVELS; ext++)
+      if (addr.s[ext] == *auto_break)
+	extcnt++;
+    for (;;) {
+      if (addr.s[ext] == *auto_break) {
+	if (!stralloc_copyb(&gmaddr, addr.s, ext + 1))
+	  die_nomem();
+	if (!stralloc_cats(&gmaddr, LDAP_CATCH_ALL))
+	  die_nomem();
+	if (!stralloc_catb(&gmaddr, addr.s + at, addr.len - at - 1))
+	  die_nomem();
+	if (constmap(&mapgma, gmaddr.s, gmaddr.len))
+	  return 1;
+      }
+      if (ext == 0)
+	break;
+      ext--;
+    }
+#endif
+    /* catchall@domain.org */
+    if (!stralloc_copys(&gmaddr, LDAP_CATCH_ALL))
+      die_nomem();
+    if (!stralloc_catb(&gmaddr, addr.s + at, addr.len - at - 1))
+      die_nomem();
+    if (constmap(&mapgma, gmaddr.s, gmaddr.len))
+      return 1;
+  }
+  return 0;
+}
+
+struct call ccverify;
+stralloc verifyresponse;
+int flagverify = 0;
+
+void ldaplookupdone(void)
+{
+  if (flagverify != 1) return;
+  call_close(&ccverify);
+  flagverify = 0;
+  return;
+}
 
-void smtp_helo(arg) char *arg;
+int ldaplookup(char *address, char **s)
 {
-  smtp_greet("250 "); out("\r\n");
+  char ch;
+  
+  if (flagverify == -1) return -1;
+  if (flagverify == 0) {
+    if (call_open(&ccverify, "bin/qmail-verify", 30, 0) == -1) {
+      flagverify = -1;
+      return -1;
+    }
+    flagverify = 1;
+  }
+  call_puts(&ccverify, address); call_putflush(&ccverify, "", 1);
+  if (call_getc(&ccverify, &ch) != 1)
+    goto fail;
+  switch (ch) {
+  case 'K':
+    return 1;
+  case 'D':
+    /* get response */
+    if (!stralloc_copys(&verifyresponse, "")) die_nomem();
+    while (call_getc(&ccverify, &ch) == 1) {
+      if (!stralloc_append(&verifyresponse, &ch)) die_nomem();
+      if (ch == 0) {
+	*s = verifyresponse.s;
+	return 0;
+      }
+    }
+    break;
+  case 'Z':
+    /* soft error */
+    if (!stralloc_copys(&verifyresponse, "")) die_nomem();
+    while (call_getc(&ccverify, &ch) == 1) {
+      if (!stralloc_append(&verifyresponse, &ch)) die_nomem();
+      if (ch == 0) {
+	*s = verifyresponse.s;
+	return -1;
+      }
+    }
+    break;
+  default:
+    break;
+  }
+fail:
+  flagverify = -1;
+  call_close(&ccverify);
+  return -1;
+}
+
+int relayprobe(void) /* relay probes trying stupid old sendwhale bugs */
+{
+  unsigned int j;
+  for (j = byte_rchr(addr.s, addr.len, '@'); j-- > 0; ) {
+    if (addr.s[j] == '@') return 1; /* double @ */
+    if (addr.s[j] == '%') return 1; /* percent relaying */
+    if (addr.s[j] == '!') return 1; /* UUCP bang path */
+  }
+  return 0;
+}
+
+
+void smtp_helo(char *arg)
+{
+  smtp_line("250 ");
   seenmail = 0; dohelo(arg);
+  logline2(4, "remote helo: ", arg);
 }
-void smtp_ehlo(arg) char *arg;
+
+void smtp_ehlo(char *arg)
 {
-  smtp_greet("250-"); out("\r\n250-PIPELINING\r\n250 8BITMIME\r\n");
+  smtp_line("250-");
+  out("250-PIPELINING\r\n");
+  if (databytes != 0) {
+    smtpsize[fmt_ulong(smtpsize, databytes)] = 0;
+    out("250-SIZE "); out(smtpsize); out("\r\n");
+  }
+#ifdef DATA_COMPRESS
+  out("250-DATAZ\r\n");
+#endif
+#ifdef TLS_SMTPD
+  if (!ssl && sslcert.s && *sslcert.s)
+    out("250-STARTTLS\r\n");
+#endif
+#ifdef TLS_SMTPD
+  if (!needssl || ssl)
+#endif
+  if (flagauth)
+    out("250-AUTH LOGIN PLAIN\r\n");
+  out("250 8BITMIME\r\n");
+
   seenmail = 0; dohelo(arg);
+  logline2(4,"remote ehlo: ",arg);
 }
-void smtp_rset()
+
+void smtp_rset(char *arg)
 {
   seenmail = 0;
+  if (relayclient != NULL && relayok == NULL)
+	  env_unset("RELAYCLIENT");
+  relayclient = relayok; /* restore original relayclient setting */
   out("250 flushed\r\n");
+  logline(4,"remote rset");
 }
-void smtp_mail(arg) char *arg;
+
+struct qmail qqt;
+
+void smtp_mail(char *arg)
 {
-  if (!addrparse(arg)) { err_syntax(); return; }
-  flagbarf = bmfcheck();
+  unsigned int i,j;
+  char *rblname;
+  int bounceflag = 0;
+
+  /* address syntax check */
+  if (!addrparse(arg))
+  {
+    err_syntax(); 
+    logline2(3,"RFC2821 syntax error in mail from: ",arg);
+    if (errdisconnect) err_quit();
+    return;
+  }
+
+  logline2(4,"mail from: ",addr.s);
+
+  if (needauth && !flagauthok) {
+    out("530 authentication needed\r\n");
+    logline(3, "auth needed");
+    if (errdisconnect) err_quit();
+    return;
+  }
+
+  /* check if we are authenticated, if yes enable relaying */
+  if (flagauthok && relayclient == 0) {
+    relayclient = "";
+    if (!env_put("RELAYCLIENT=")) die_nomem();
+  }
+
+  /* smtp size check */
+  if (databytes && !sizelimit(arg))
+  {
+    err_size(); /* logging is done in error routine */
+    if (errdisconnect) err_quit();
+    return;
+  }
+
+  /* bad mailfrom check */
+  if (bmfcheck())
+  {
+    err_bmf();
+    logline2(3,"bad mailfrom: ",addr.s);
+    if (errdisconnect) err_quit();
+    return;
+  }
+  /* bad mailfrom unknown check */
+  if (bmfunknowncheck())
+  {
+    err_bmfunknown();
+    logline2(3,"bad mailfrom unknown: ",addr.s);
+    if (errdisconnect) err_quit();
+    return;
+  }
+
+  /* NOBOUNCE check */
+  if (!addr.s[0] || !str_diff("#@[]", addr.s))
+  {
+    bounceflag = 1;
+    if (nobounce)
+    {
+      err_554msg("RFC2821 bounces are administratively denied");
+      if (errdisconnect) err_quit();
+      return;
+    }
+  }
+
+  /* Sanity checks */
+  if (sanitycheck && !bounceflag)
+  {
+    /* Invalid Mailfrom */
+    if ((i=byte_rchr(addr.s,addr.len,'@')) >= addr.len)
+    {
+      err_554msg("mailfrom without @ is administratively denied");
+      if (errdisconnect) err_quit();
+      return;
+    }
+    if (i == 0 || addr.s[i+1] == '\0') {
+      err_554msg("mailfrom without user or domain part is "
+        "administratively denied");
+      if (errdisconnect) err_quit();
+      return;
+    }
+    /* No '.' in domain.TLD */
+    if ((j = byte_rchr(addr.s+i, addr.len-i, '.')) >= addr.len-i) {
+      err_554msg("mailfrom without . in domain part is "
+        "administratively denied");
+      if (errdisconnect) err_quit();
+      return;
+    }
+    /* check tld length */
+    j = addr.len-(i+1+j+1);
+    if (j < 2 || j > 6)
+    {
+      /* XXX: This needs adjustment when new TLD's are constituded.
+       * OK, now after the candidates are nominated we know new TLD's
+       * may contain up to six characters.
+       */
+      err_554msg("mailfrom without country or top level domain is "
+        "administratively denied");
+      if (errdisconnect) err_quit();
+      return;
+     }
+  }
+
+  /* relay mail from check (allow relaying based on evelope sender address) */
+  if (!relayclient) {
+    if (rmfcheck()) {
+      relayclient = "";
+      if (!env_put("RELAYCLIENT=")) die_nomem();
+      logline(4,"relaying allowed via relaymailfrom");
+    }
+  }
+
+  /* Check RBL only if relayclient is not set */
+  if (rblok && !relayclient)
+  {
+    switch(rblcheck(remoteip, &rblname, rbloh))
+    {
+      case 2: /* soft error lookup */
+        /*
+         * continue if  RBL DNS has a problem. if a RBL is unreachable
+         * we dont want to fail. accept message anyway. a false negative
+         * is better in this case than rejecting every message just
+         * because one RBL failed. play safe, might be an important mail.
+         */
+        break;
+      case 1: /* host is listed in RBL */
+        err_rbl(rblname);
+        if (errdisconnect) err_quit();
+        return;
+      default: /* ok, go ahead */
+        logline(4,"RBL checking completed");
+        break;
+    }
+  }
+
+  /* return MX check */
+  if (returnmxcheck && !bounceflag)
+  {
+    if ((i=byte_rchr(addr.s,addr.len,'@')) < addr.len)
+      switch (badmxcheck(&addr.s[i+1]))
+      {
+	case 0:
+	  break; /* valid */
+	case DNS_SOFT:
+	  err_dns();
+	  logline(3,"refused mailfrom because return MX lookup "
+            "failed temporarly");
+	  if (errdisconnect) err_quit();
+	  return;
+	case DNS_HARD:
+	default:
+	  err_554msg("refused mailfrom because return MX does not exist");
+	  if (errdisconnect) err_quit();
+	  return;
+      }
+  }
+
+  /* check if sender exists in ldap */
+  if (sendercheck && !bounceflag) {
+    if (!goodmailaddr()) { /* good mail addrs go through anyway */
+      logline(4,"sender verify, sender not in goodmailaddr");
+      if (addrlocals()) {
+	char *s;
+	logline(4,"sender verify, sender is local");
+        switch (ldaplookup(addr.s, &s)) {
+          case 1: /* valid */
+	    logline(4,"sender verify OK");
+            break;
+          case 0: /* invalid */
+	    logline2(2, "bad sender: ", addr.s);
+            err_554msg(s);
+            if (errdisconnect) err_quit();
+            return;
+          case -1:
+          default: /* other error, treat as soft 4xx */
+            if (ldapsoftok)
+              break;
+            err_soft(s);
+            if (errdisconnect) err_quit();
+            return;
+        }
+      } else {
+        /* not in addrlocals, ldap lookup is useless */
+        /* normal mode: let through, it's just an external mail coming in */
+        /* loose mode (2): see if sender is in rcpthosts, if no reject here */
+        /* strict mode (3): validated sender required so reject in any case */
+        if ((sendercheck == 2 && !addrallowed()) || sendercheck == 3) {
+          err_554msg("refused mailfrom because valid "
+            "local sender address required");
+          if (errdisconnect) err_quit();
+          return;
+        }
+      }
+    }
+  }
+
   seenmail = 1;
   if (!stralloc_copys(&rcptto,"")) die_nomem();
   if (!stralloc_copys(&mailfrom,addr.s)) die_nomem();
   if (!stralloc_0(&mailfrom)) die_nomem();
+  rcptcount = 0;
+  if (loglevel < 4)
+    logline2(2,"mail from: ",mailfrom.s);
   out("250 ok\r\n");
 }
-void smtp_rcpt(arg) char *arg; {
-  if (!seenmail) { err_wantmail(); return; }
-  if (!addrparse(arg)) { err_syntax(); return; }
-  if (flagbarf) { err_bmf(); return; }
+
+void smtp_rcpt(char *arg)
+{
+  if (!seenmail)
+  {
+    err_wantmail();
+    if (errdisconnect) err_quit();
+    return;
+  }
+
+  /* syntax check */
+  if (!addrparse(arg))
+  {
+    err_syntax();
+    logline2(3,"syntax error in 'rcpt to': ",arg);
+    if (errdisconnect) err_quit();
+    return;
+  }
+
+  logline2(4,"rcpt to: ",addr.s);
+
+  /* block stupid and bogus sendwhale bug relay probing */
+  /* don't enable this if you use percenthack */
+  if (blockrelayprobe && relayprobe()) {
+    err_relay();
+    logline(3,"'rcpt to' denied, looks like bogus sendwhale bug relay probe");
+    if (errdisconnect) err_quit();
+    return;
+  }
+
+  /* do we block this recipient */
+  if (rcptdenied()) {
+    err_badrcptto();
+    logline2(3,"'rcpt to' denied via badrcptto: ",addr.s);
+    if (errdisconnect) err_quit();
+    return;
+  }
+
+  /* is sender ip allowed to relay */
   if (relayclient) {
     --addr.len;
     if (!stralloc_cats(&addr,relayclient)) die_nomem();
     if (!stralloc_0(&addr)) die_nomem();
+  } else {
+    if (!addrallowed()) { 
+      err_nogateway();
+      logline2(3,"no mail relay for 'rcpt to': ",addr.s);
+      if (errdisconnect) err_quit();
+      return; 
+    }
   }
-  else
-    if (!addrallowed()) { err_nogateway(); return; }
+  ++rcptcount;
+
+  /* maximum recipient limit reached */
+  if (maxrcptcount && rcptcount > maxrcptcount) {
+    err_maxrcpt();
+    logline(3,"message denied because of more 'RCPT TO' than "
+      "allowed by MAXRCPTCOUNT");
+    if (errdisconnect) err_quit();
+    return;
+  }
+
+  /* only one recipient for bounce messages */
+  if (rcptcount > 1 && (!mailfrom.s[0] || !str_diff("#@[]", mailfrom.s))) {
+    err_badbounce();
+    logline(3,"bounce message denied because it has more than one recipient");
+    if (errdisconnect) err_quit();
+    return;
+  }
+
+  /* check if recipient exists in ldap */
+  if (rcptcheck) {
+    if (!goodmailaddr()) {
+      logline(4,"recipient verify, recipient not in goodmailaddr");
+      if (addrlocals()) {
+	char *s;
+	logline(4,"recipient verify, recipient is local");
+        switch (ldaplookup(addr.s, &s)) {
+          case 1: /* valid */
+	    logline(4,"recipient verify OK");
+            break;
+          case 0: /* invalid */
+	    logline2(2, "bad recipient: ", addr.s);
+            err_554msg(s);
+            if (errdisconnect) err_quit();
+            return;
+          case -1:
+          default: /* other error, treat as soft 4xx */
+            if (ldapsoftok)
+              break;
+            err_soft(s);
+            if (errdisconnect) err_quit();
+            return;
+        }
+      } /* else this is relaying, don't do anything */
+    }
+  }
+
+  if (loglevel < 4)
+    logline2(2,"rcpt to: ",addr.s);
   if (!stralloc_cats(&rcptto,"T")) die_nomem();
   if (!stralloc_cats(&rcptto,addr.s)) die_nomem();
   if (!stralloc_0(&rcptto)) die_nomem();
+  if (tarpitcount && tarpitdelay && rcptcount >= tarpitcount) {
+    logline(3,"tarpitting");
+    while (sleep(tarpitdelay));
+  }
   out("250 ok\r\n");
 }
 
+#ifdef DATA_COMPRESS
+z_stream stream;
+char zbuf[4096];
+int wantcomp = 0;
+int compdata = 0;
+
+int compression_init(void)
+{
+  compdata = 1;
+  stream.zalloc = Z_NULL;
+  stream.zfree = Z_NULL;
+  stream.opaque = Z_NULL;
+  stream.avail_in = 0;
+  stream.next_in = zbuf;
+  if (inflateInit(&stream) != Z_OK) {
+    out("451 Initalizing data compression failed: ");
+    out(stream.msg); out(" #(4.3.0)\r\n"); flush();
+    return -1;
+  }
+  return 0;
+}
+int compression_done(void)
+{
+  char num[FMT_ULONG + 1];
+  int r;
+
+  compdata = 0;
+  if (stream.avail_out != sizeof(zbuf)) {
+    /* there is some left data, ignore */
+  }
+  if (inflateEnd(&stream) != Z_OK) {
+    out("451 Finishing data compression failed: ");
+    out(stream.msg); out(" #(4.3.0)\r\n"); flush();
+    return -1;
+  }
+  r = 100 - (int)(100.0*stream.total_in/stream.total_out);
+  if (r < 0) {
+    num[0] = '-';
+    r *= -1;
+  } else
+    num[0] = ' ';
+  num[fmt_uint(num+1,r)+1] = 0;
+  logpid(3);
+  logstring(3,"DDC saved ");
+  logstring(3,num);
+  logstring(3," percent");
+  logflush(3);
+  return 0;
+}
+#endif
 
-int saferead(fd,buf,len) int fd; char *buf; int len;
+int saferead(int fd,void *buf,int len)
 {
   int r;
   flush();
+#ifdef DATA_COMPRESS
+  if (compdata) {
+    stream.avail_out = len;
+    stream.next_out = buf;
+    do {
+      if (stream.avail_in == 0) {
+#ifdef TLS_SMTPD
+	if (ssl)
+	  r = ssl_timeoutread(timeout,fd,zbuf,sizeof(zbuf));
+	else
+#endif
+	r = timeoutread(timeout,fd,zbuf,sizeof(zbuf));
+	if (r == -1) if (errno == error_timeout) die_alarm();
+	if (r <= 0) die_read();
+	stream.avail_in = r;
+	stream.next_in = zbuf;
+      }
+      r = inflate(&stream, 0);
+      switch (r) {
+      case Z_OK:
+	if (stream.avail_out == 0)
+	  return len;
+	break;
+      case Z_STREAM_END:
+	compdata = 0;
+	return len - stream.avail_out;
+      default:
+	out("451 Receiving compressed data failed: ");
+	out(stream.msg); out(" #(4.3.0)\r\n");
+	logline2(1, "compressed data read failed: ", stream.msg);
+	flush();
+	die_read();
+      }
+      if (stream.avail_out == (unsigned int)len) continue;
+      return len - stream.avail_out;
+    } while (1);
+  }
+#endif
+#ifdef TLS_SMTPD
+  if (ssl)
+    r = ssl_timeoutread(timeout,fd,buf,len);
+  else
+#endif
   r = timeoutread(timeout,fd,buf,len);
   if (r == -1) if (errno == error_timeout) die_alarm();
   if (r <= 0) die_read();
@@ -278,25 +1301,27 @@
 char ssinbuf[1024];
 substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);
 
-struct qmail qqt;
-unsigned int bytestooverflow = 0;
+unsigned long bytestooverflow = 0;
+unsigned long bytesreceived = 0;
 
-void put(ch)
-char *ch;
+void put(const char *ch)
 {
+#ifdef SMTPEXECCHECK
+  execcheck_put(&qqt, ch);
+#endif
   if (bytestooverflow)
     if (!--bytestooverflow)
       qmail_fail(&qqt);
   qmail_put(&qqt,ch,1);
+  ++bytesreceived;
 }
 
-void blast(hops)
-int *hops;
+void blast(unsigned int *hops)
 {
   char ch;
   int state;
   int flaginheader;
-  int pos; /* number of bytes since most recent \n, if fih */
+  unsigned int pos; /* number of bytes since most recent \n, if fih */
   int flagmaybex; /* 1 if this line might match RECEIVED, if fih */
   int flagmaybey; /* 1 if this line might match \r\n, if fih */
   int flagmaybez; /* 1 if this line might match DELIVERED, if fih */
@@ -318,6 +1343,7 @@
         if (flagmaybey) if (pos == 1) flaginheader = 0;
       }
       ++pos;
+      if (pos > MAXLINELEN) oversizedline();
       if (ch == '\n') { pos = 0; flagmaybex = flagmaybey = flagmaybez = 1; }
     }
     switch(state) {
@@ -351,49 +1377,331 @@
   }
 }
 
-char accept_buf[FMT_ULONG];
-void acceptmessage(qp) unsigned long qp;
+void acceptmessage(unsigned long qp)
 {
+  static char buf[FMT_ULONG];
+
   datetime_sec when;
   when = now();
   out("250 ok ");
-  accept_buf[fmt_ulong(accept_buf,(unsigned long) when)] = 0;
-  out(accept_buf);
+  buf[fmt_ulong(buf,(unsigned long) when)] = 0;
+  out(buf);
+  logpid(2); logstring(2,"message queued: "); logstring(2,buf);
   out(" qp ");
-  accept_buf[fmt_ulong(accept_buf,qp)] = 0;
-  out(accept_buf);
+  buf[fmt_ulong(buf,qp)] = 0;
+  out(buf);
+  out(" by ");
+  out(me.s);
   out("\r\n");
+  logstring(2," qp "); logstring(2,buf);
+  buf[fmt_ulong(buf, bytesreceived)] = 0;
+  logstring(2, " size ");
+  logstring(2, buf);
+  logstring(2, " bytes");
+  logflush(2);
 }
 
-void smtp_data() {
-  int hops;
+#ifdef TLS_SMTPD
+stralloc protocolinfo = {0};
+#endif
+
+void smtp_data(char *arg) {
+  unsigned int hops;
   unsigned long qp;
-  char *qqx;
- 
-  if (!seenmail) { err_wantmail(); return; }
-  if (!rcptto.len) { err_wantrcpt(); return; }
+  const char *qqx;
+
+  ldaplookupdone();
+  if (!seenmail) {
+    err_wantmail();
+    if (errdisconnect) err_quit();
+    return;
+  }
+  if (!rcptto.len) {
+    err_wantrcpt();
+    if (errdisconnect) err_quit();
+    return;
+  }
   seenmail = 0;
   if (databytes) bytestooverflow = databytes + 1;
-  if (qmail_open(&qqt) == -1) { err_qqt(); return; }
+#ifdef SMTPEXECCHECK
+  execcheck_start();
+#endif
+  if (qmail_open(&qqt) == -1) {
+    err_qqt();
+    logline(1,"failed to start qmail-queue");
+    return;
+  }
   qp = qmail_qp(&qqt);
-  out("354 go ahead\r\n");
- 
-  received(&qqt,"SMTP",local,remoteip,remotehost,remoteinfo,fakehelo);
+  out("354 go ahead punk, make my day\r\n"); logline(4,"go ahead");
+  rblheader(&qqt);
+
+#ifdef TLS_SMTPD
+  if(ssl){
+    if (!stralloc_copys(&protocolinfo,
+       SSL_CIPHER_get_name(SSL_get_current_cipher(ssl)))) die_nomem();
+#ifdef DATA_COMPRESS
+    if (wantcomp) {
+      if (!stralloc_cats(&protocolinfo, " encrypted compressed SMTP"))
+	die_nomem();
+    } else
+#endif
+    if (!stralloc_cats(&protocolinfo, " encrypted SMTP")) die_nomem();
+  } else {
+#ifdef DATA_COMPRESS
+    if (wantcomp) {
+      if (!stralloc_copys(&protocolinfo,"compressed SMTP")) die_nomem();
+    } else
+#endif
+    if (!stralloc_copys(&protocolinfo,"SMTP")) die_nomem();
+  }
+  if (!stralloc_0(&protocolinfo)) die_nomem();
+  received(&qqt,protocolinfo.s,local,remoteip,remotehost,remoteinfo,fakehelo,mailfrom.s,&rcptto.s[1]);
+#else 
+#ifdef DATA_COMPRESS
+  if (wantcomp)
+    received(&qqt,"compressed SMTP",local,remoteip,remotehost,remoteinfo,fakehelo,mailfrom.s,&rcptto.s[1]);
+  else
+#endif
+    received(&qqt,"SMTP",local,remoteip,remotehost,remoteinfo,fakehelo,mailfrom.s,&rcptto.s[1]);
+#endif
+
+#ifdef DATA_COMPRESS
+  if (wantcomp) { if (compression_init() != 0) return; }
+#endif
   blast(&hops);
+#ifdef DATA_COMPRESS
+  if (wantcomp) { if (compression_done() != 0) return; }
+#endif
+
   hops = (hops >= MAXHOPS);
-  if (hops) qmail_fail(&qqt);
+  if (hops)
+    qmail_fail(&qqt);
   qmail_from(&qqt,mailfrom.s);
   qmail_put(&qqt,rcptto.s,rcptto.len);
  
   qqx = qmail_close(&qqt);
   if (!*qqx) { acceptmessage(qp); return; }
-  if (hops) { out("554 too many hops, this message is looping (#5.4.6)\r\n"); return; }
-  if (databytes) if (!bytestooverflow) { out("552 sorry, that message size exceeds my databytes limit (#5.3.4)\r\n"); return; }
-  if (*qqx == 'D') out("554 "); else out("451 ");
+  if (hops) {
+    out("554 too many hops, this message is looping (#5.4.6)\r\n");
+    logline(3,"too many hops, message is looping");
+    if (errdisconnect) err_quit();
+    return;
+  }
+  if (databytes) if (!bytestooverflow) {
+    out("552 sorry, that message size exceeds my databytes limit (#5.3.4)\r\n");
+    logline(3,"datasize limit exceeded");
+    if (errdisconnect) err_quit();
+    return;
+  }
+#ifdef SMTPEXECCHECK
+  if (execcheck_flag()) {
+    out("552 we don't accept email with this MIME content (#5.3.4)\r\n");
+    logline(3,"bad MIME attachement detected");
+    if (errdisconnect) err_quit();
+    return;
+  }
+#endif
+
+  logpid(1);
+  if (*qqx == 'D') {
+    out("554 "); logstring(1,"message permanently not accepted because: ");
+  } else {
+    out("451 "); logstring(1,"message temporarly not accepted because: ");
+  }
   out(qqx + 1);
+  logstring(1,qqx + 1); logflush(1);
   out("\r\n");
 }
 
+#ifdef DATA_COMPRESS
+void smtp_dataz(char *arg)
+{
+  wantcomp = 1;
+  smtp_data((char *)0);
+}
+#endif
+
+stralloc line = {0};
+
+void smtp_auth(char *arg)
+{
+  struct call cct;
+  char *type;
+  const char *status;
+
+  if (!flagauth) {
+    err_unimpl("AUTH without STARTTLS");
+    return;
+  }
+  if (flagauthok) {
+    out("503 you are already authenticated\r\n");
+    logline(3,"reauthentication attempt rejected");
+    if (errdisconnect) err_quit();
+    return;
+  }
+#ifdef TLS_SMTPD
+  if (needssl && !ssl) {
+    out("538 Encryption required for requested authentication mechanism");
+    logline(3,"TLS encryption required for authentication");
+    if (errdisconnect) err_quit();
+    return;
+  }
+#endif
+  type = arg;
+  while (*arg != '\0' && *arg != ' ') ++arg;
+  if (*arg) {
+    *arg++ = '\0';
+    while (*arg == ' ') ++arg;
+  }
+  
+  if (case_diffs(type, "login") == 0) {
+    logline(4,"auth login");
+    if (call_open(&cct, "bin/auth_smtp", 30, 1) == -1) goto fail;
+    call_puts(&cct, "login"); call_put(&cct, "", 1);
+    if (*arg) {
+      call_puts(&cct, arg); call_put(&cct, "", 1);
+    } else {
+      out("334 VXNlcm5hbWU6\r\n"); flush(); /* base64 for 'Username:' */
+      if (call_getln(&ssin, &line) == -1) die_read();
+      call_puts(&cct, line.s); call_put(&cct, "", 1);
+    }
+    out("334 UGFzc3dvcmQ6\r\n"); flush(); /* base64 for 'Password:' */
+    if (call_getln(&ssin, &line) == -1) die_read();
+    call_puts(&cct, line.s); call_putflush(&cct, "", 1);
+  } else if (case_diffs(type, "plain") == 0) {
+    logline(4,"auth plain");
+    if (call_open(&cct, "bin/auth_smtp", 30, 1) == -1) goto fail;
+    call_puts(&cct, "plain"); call_put(&cct, "", 1);
+    if (*arg) {
+      call_puts(&cct, arg); call_putflush(&cct, "", 1);
+    } else {
+      out("334 \r\n"); flush();
+      if (call_getln(&ssin, &line) == -1) die_read();
+      call_puts(&cct, line.s); call_putflush(&cct, "", 1);
+    }
+  } else {
+    out("504 authentication type not supported\r\n");
+    logstring(3,"authentication type ");
+    logstring(3,type);
+    logstring(3,": not supported");
+    logflush(3);
+    if (errdisconnect) err_quit();
+    return;
+  }
+fail:
+  status = auth_close(&cct, &line, authprepend);
+  switch (*status) {
+  case '2':
+    flagauthok = 1;
+    remoteinfo = line.s;
+    out(status);
+    logline2(2,"authentication success, user ", remoteinfo);
+    break;
+  case '4':
+  case '5':
+    sleep(1);
+    out(status); flush();
+    logline2(3, "authentication failed: ", status + 4);
+    sleep(4);
+    if (errdisconnect) err_quit();
+    break;
+  }
+}
+
+#ifdef TLS_SMTPD
+RSA *tmp_rsa_cb(SSL *s,int export,int keylength) 
+{
+  RSA* rsa;
+  BIO* in;
+
+  if (!export || keylength == 512)
+   if ((in=BIO_new(BIO_s_file_internal())))
+    if (BIO_read_filename(in,"control/rsa512.pem") > 0)
+     if ((rsa=PEM_read_bio_RSAPrivateKey(in,NULL,NULL,NULL)))
+      return rsa;
+  return (RSA_generate_key(export?keylength:512,RSA_F4,NULL,NULL));
+}
+
+void smtp_tls(char *arg) 
+{
+  SSL_CTX *ctx;
+
+  if (sslcert.s == 0 || *sslcert.s == '\0') {
+    err_unimpl("STARTTLS");
+    return;
+  }
+
+  if (*arg)
+  {
+    out("501 Syntax error (no parameters allowed) (#5.5.4)\r\n");
+    logline(3,"aborting TLS negotiations, no parameters to starttls allowed");
+    return;
+  }
+
+  SSLeay_add_ssl_algorithms();
+  if(!(ctx=SSL_CTX_new(SSLv23_server_method())))
+  {
+    out("454 TLS not available: unable to initialize ctx (#4.3.0)\r\n"); 
+    logline(3,"aborting TLS negotiations, "
+      "unable to initialize local SSL context");
+    return;
+  }
+  if(!SSL_CTX_use_RSAPrivateKey_file(ctx, sslcert.s, SSL_FILETYPE_PEM))
+  {
+    out("454 TLS not available: missing RSA private key (#4.3.0)\r\n");
+    logline2(3,"aborting TLS negotiations, "
+      "RSA private key invalid or unable to read ", sslcert.s);
+    return;
+  }
+  if(!SSL_CTX_use_certificate_chain_file(ctx, sslcert.s))
+  {
+    out("454 TLS not available: missing certificate (#4.3.0)\r\n"); 
+    logline2(3,"aborting TLS negotiations, "
+      "local cert invalid or unable to read ", sslcert.s);
+    return;
+  }
+  SSL_CTX_set_tmp_rsa_callback(ctx, tmp_rsa_cb);
+ 
+  out("220 ready for tls\r\n"); flush();
+
+  if(!(ssl=SSL_new(ctx))) 
+  {
+    logline(3,"aborting TLS connection, unable to set up SSL session");
+    die_read();
+  }
+  SSL_set_rfd(ssl,substdio_fileno(&ssin));
+  SSL_set_wfd(ssl,substdio_fileno(&ssout));
+  if(SSL_accept(ssl)<=0)
+  {
+    logline(3,"aborting TLS connection, unable to finish SSL accept");
+    die_read();
+  }
+  //substdio_fdbuf(&ssout,SSL_write,ssl,ssoutbuf,sizeof(ssoutbuf));
+
+  remotehost = env_get("TCPREMOTEHOST");
+  if (!remotehost) remotehost = "unknown";
+  dohelo(remotehost);
+}
+#endif
+
+void cleanup(void)
+{
+	ldaplookupdone();
+}
+
+void err_503or421(char *arg)
+{
+  if (greeting421)
+    out("421 Service temporarily not available (#4.3.2)\r\n");
+  else
+    out("503 bad sequence of commands (#5.5.1)\r\n");
+  if (errdisconnect) err_quit();
+}
+void err_badcommand(char *arg)
+{
+  out("503 bad sequence of commands (#5.5.1)\r\n");
+}
+
 struct commands smtpcommands[] = {
   { "rcpt", smtp_rcpt, 0 }
 , { "mail", smtp_mail, 0 }
